'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-3c56ce3c.js');

const fdiContainerCss = ".fdi.wc.container .titleContainer{width:100%}.fdi.wc.container .titleContainer .collapseTrigger{padding:0 5px}.fdi.wc.container .titleContainer .collapseTrigger:hover{cursor:pointer}.fdi.wc.container .menu{width:100%}.fdi.wc.container .menu ul li{display:inline-block;margin-right:10px;padding:5px}.fdi.wc.container .menu ul li:hover{background:#ececec;cursor:pointer}.fdi.wc.container .content{width:100%}";
const FdiContainerStyle0 = fdiContainerCss;

const FDIContainer = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.__settings = undefined;
        this.settings = {
            title: '',
            expandText: '&#9660; ',
            collapseText: '&#9650; ',
            allowCollapse: true,
            initializeCollapsed: false,
            showMenu: true,
            style: {
                titleContainer: {
                    textAlign: 'center'
                },
                container: {},
                menu: {},
                content: {
                    overflow: 'hidden',
                },
            },
            meta: {}
        };
        this.collapsed = false;
    }
    componentWillLoad() {
        let settings = this.__settings;
        if (typeof settings === 'string') {
            settings = JSON.parse(this.__settings);
        }
        this.settings = Object.assign(Object.assign({}, this.settings), settings);
        if (this.settings.initializeCollapsed)
            this.collapsed = true;
        if (!this.settings.allowCollapse)
            this.collapsed = false;
    }
    render() {
        let contentHeight = `${this.collapsed ? 0 : (this.settings.style.content.height || 'auto')}`;
        let expandAndCollapseText = this.collapsed ? this.settings.expandText : this.settings.collapseText;
        return (index.h("div", { key: '8554075bc0811117ec177f6beeeae68deadf8b25', class: 'fdi wc container', style: this.settings.style.container }, index.h("div", { key: 'e6bd5785bcd62be56213e0133e7ede0061aa1c35', class: 'titleContainer', style: this.settings.style.titleContainer }, index.h("h1", { key: '996ae25f6e4331662e438691be332395403fe4ae' }, this.settings.allowCollapse &&
            index.h("span", { key: '9b2cb4dcbf783184b32484dc6b86d6948ba9f585', class: 'collapseTrigger', onClick: () => { this.collapsed = !this.collapsed; }, innerHTML: expandAndCollapseText }, " "), index.h("span", { key: '7e3ef0b8e675999ce0b3e759b1ae26f8714e9567', innerHTML: this.settings.title ? this.settings.title : '' }, " "))), this.settings.showMenu &&
            index.h("div", { key: 'bfb04be134953ee622f35bb122d49f8743bc109d', class: 'menu', style: this.settings.style.menu }, index.h("ul", { key: '709e518c7c697a17c9e8fa288be87236f26f46f3' })), index.h("div", { key: '563482c2e1336a9d41d5fc2bec0f9557d2f1d5ad', class: 'content', style: Object.assign(Object.assign({}, this.settings.style.content), { height: contentHeight }) }, index.h("slot", { key: '150edd8652beec2d8959926805f0f203a9e55b1a' }))));
    }
};
FDIContainer.style = FdiContainerStyle0;

exports.fdi_container = FDIContainer;

//# sourceMappingURL=fdi-container.cjs.entry.js.map