'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-3c56ce3c.js');
const v4 = require('./v4-078aedb1.js');

const fdiWizardsCss = ".wizards-wizard{display:inline-block;margin:10px;padding:10px;border:solid 1px #ccc}button{cursor:pointer;margin:5px}h2{text-align:center}";
const FdiWizardsStyle0 = fdiWizardsCss;

const FdiWizards = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.wizardsComplete = index.createEvent(this, "fdi_wc_wizardsComplete", 7);
        this.__wizards = undefined;
        this.__displayFields = undefined;
        this.__title = undefined;
        this.__templateId = undefined;
        this.id = undefined;
        this.wizards = undefined;
        this.displayFields = undefined;
        this.activeWizard = undefined;
    }
    finish() {
        this.wizardsComplete.emit({
            wizards: this.wizards,
        });
    }
    fdi_wc_input_change__handler(ev) {
        const { detail } = ev;
        console.log({ detail });
        if (detail.master === this.id) {
            const currentWizard = this.wizards.get(detail.wizardId);
            if (currentWizard) {
                currentWizard.existingAnswers = detail.formatted_answers;
                this.cancelWizard();
            }
        }
    }
    async componentWillLoad() {
        this.id = v4.v4();
        if (this.__wizards) {
            this.wizards = new Map();
            const temp = JSON.parse(this.__wizards);
            temp.forEach(wizard => {
                this.wizards.set(v4.v4(), wizard);
            });
        }
        if (this.__displayFields) {
            this.displayFields = JSON.parse(this.__displayFields);
        }
    }
    openWizard(key) {
        if (!this.activeWizard) {
            this.activeWizard = key;
        }
    }
    cancelWizard() {
        if (this.activeWizard) {
            this.activeWizard = null;
        }
    }
    removeWizard(key) {
        this.wizards.delete(key);
        index.forceUpdate(this);
    }
    addWizard() {
        this.wizards.set(v4.v4(), {
            existingAnswers: {},
        });
        index.forceUpdate(this);
    }
    render() {
        const displays = [...this.wizards.entries()].map(([key, wizard]) => {
            const values = this.displayFields.map(field => {
                let value = wizard.existingAnswers[field] || null;
                if (Array.isArray(value)) {
                    value = value.join(',');
                }
                return (index.h("div", null, field, ": ", value));
            });
            return (index.h("div", { class: "wizards-wizard" }, values, index.h("button", { onClick: () => this.openWizard(key) }, "Edit"), index.h("button", { onClick: () => this.removeWizard(key) }, "Delete")));
        });
        return (index.h("div", null, index.h("h2", null, this.__title), this.activeWizard &&
            index.h("div", null, index.h("fdi-wizard", { "__existing-answers": JSON.stringify(this.wizards.get(this.activeWizard).existingAnswers), __master: this.id, "__wizard-id": this.activeWizard, "__template-id": this.__templateId }), index.h("div", null, index.h("button", { onClick: () => this.cancelWizard() }, "Cancel"))), !this.activeWizard && displays, !this.activeWizard && index.h("button", { onClick: () => this.addWizard() }, "Add New"), !this.activeWizard && index.h("button", { onClick: () => this.finish() }, "Save Changes")));
    }
};
FdiWizards.style = FdiWizardsStyle0;

exports.fdi_wizards = FdiWizards;

//# sourceMappingURL=fdi-wizards.cjs.entry.js.map