function format(first, middle, last) {
    return (first || '') + (middle ? ` ${middle}` : '') + (last ? ` ${last}` : '');
}
function overrideSettings(defaultSettings, overrides) {
    let settings = Object.assign({}, defaultSettings);
    if (overrides === null || overrides === undefined)
        return settings;
    for (const [prop, value] of Object.entries(overrides)) {
        if (settings && settings.hasOwnProperty(prop)) {
            if (typeof value === 'object' && value !== null && !Array.isArray(value)) {
                settings[prop] = overrideSettings(defaultSettings[prop], overrides[prop]);
            }
            else {
                settings[prop] = overrides[prop];
            }
        }
        else {
            settings[prop] = overrides[prop];
        }
    }
    return settings;
}

export { format as f, overrideSettings as o };

//# sourceMappingURL=utils-683caad7.js.map